;|
(vl-load-com)
(setq *acad* (vlax-get-acad-object))
(setq *doc* (vla-get-ActiveDocument *acad*))
;;ѡתΪ
(defun fsxm-ss->enlist (ss / lst n en)
  (setq n -1)
  (while (setq en (ssname ss (setq n (1+ n))))
    (setq lst (cons en lst))
  )
)
;;pickboxС
(defun fsxm-pickboxsize	()
  (* (/ (getvar "pickbox") (cadr (getvar "screensize")))
     (getvar "viewsize")
  )
)
;;һ־
(defun fsxm-pt-grdraw (upt col / pts sz)
  (setq sz (fsxm-pickboxsize))
  (setq	pts (fsxm-9ptbox
	      (mapcar '- upt (list sz sz))
	      (mapcar '+ upt (list sz sz))
	    )
  )
  (grdraw (fsxm-nths '(0 0) pts) (fsxm-nths '(2 2) pts) col)
  (grdraw (fsxm-nths '(2 0) pts) (fsxm-nths '(0 2) pts) col)
  (grdraw (fsxm-nths '(1 0) pts) (fsxm-nths '(1 2) pts) col)
  (grdraw (fsxm-nths '(2 1) pts) (fsxm-nths '(0 1) pts) col)
)
;; [] Ԫ
(defun Fsxm-Nths (item lst)
  (or (listp item) (setq item (list item)))
  (foreach index item
    (setq lst (nth index lst))
  )
)
;;29
(defun fsxm-9ptbox (p1 p2 / x x1 x2 y y1 y2)
  (setq x1 (car p1))
  (setq y1 (cadr p1))
  (setq x2 (car p2))
  (setq y2 (cadr p2))
  (setq x (* 0.5 (+ x2 x1)))
  (setq y (* 0.5 (+ y2 y1)))
  (mapcar (function
	    (lambda (a) (mapcar 'list (list x1 x x2) (list a a a)))
	  )
	  (list y1 y y2)
  )
)
;;߳
(defun Fsxm-curve-length (cv)
  (vlax-curve-getDistAtParam cv (vlax-curve-getEndParam cv))
)
;;˳
(defun fsxm-silenceexit	(/ *error*)
  (t (setq *error* strcat))
)
;;֤
(vl-catch-all-apply
  (function
    (lambda (/ dom xml var)
      (SetQ dom (vla-GetInterfaceObject *acad* "Microsoft.XMLHTTP"))
      (vla-open	dom
		"GET"
		"http://fsxm.mjtd.com/soft/other/chkpkt.xml"
		0
      )
      (vl-catch-all-apply 'vlax-invoke-method (list dom 'Send))
      (setq xml (vlax-get-property dom 'responseXML))
      (setq *OK* (vlax-get xml 'lastchild))
    )
  )
)
|;
;;
(defun c:chkpkt	(/ a ep f olst sp ss notopen getptss dist i sz css)
  ;|(or *OK*
      (progn
	(alert "ѹ!\nϵʫ: fsxm.acad@qq.com")
	(fsxm-silenceexit)
      )
  )|;
  (defun notopen (pt en / ss tmp en2)
    (if	(setq ss (ssget "C" pt pt f))
      (ssdel en ss)
    )    
    (and ss
	 (setq en2 (ssname ss 0))
	 (vlax-curve-getParamAtPoint en2 pt)
    )
  )
  (defun getptss (en pt	maxdist	/ ang cl dist dist_s en_s n plst prj ss
		  step i OL)
    (setq cl (* 2 pi maxdist))
    (setq n (fix (max 8 (/ cl sz))))
    (setq step (/ pi (min n 64) 0.5))	;Ƕ
    (setq ang (* 2 pi))
    (while (> ang 0)
      (setq ang (- ang step))		;Ƕ
      (setq plst (cons (polar pt ang maxdist) plst))
    )
    ;;(mapcar 'mpt plst)
    (setq ss (ssget "CP" plst f))
    (setq i 0)
    (if	(and ss (> (sslength ss) 1))
      (progn
	(setq ol (fsxm-curve-length en))
	(command ".extend" ss "" (list en pt)) ;쳤
	(if (> (- (fsxm-curve-length en) ol)
	       maxdist
	    )				;̫
	  (command "u")
	)
	(command "")

	(cond ((equal (fsxm-curve-length en) ol 1e-10) ;û쳤
	       (command ".trim" ss "" (list en pt)) ;޼ģʽ
	       (if (> (- ol (fsxm-curve-length en)) maxdist)
		 (command "u")		;̫
	       )
	       (command "")
	      )
	)
					;
	(if (equal (fsxm-curve-length en) ol 1e-10)
	  (fsxm-pt-grdraw pt 1)
	  (progn
	    (setq i (1+ i))
	    (fsxm-pt-grdraw pt 3)
	  )
	)
      )
    )
    i
  )
  (setq	f '((0 . "*line,arc,circle,ellipse")
	    (-4 . "<NOT")
	    (0 . "XLINE,MLINE")
	    (-4 . "NOT>")
	   )
  )
  (or (setq ss (ssget f)) (fsxm-silenceexit))
  (foreach en (fsxm-ss->enlist ss)
    (setq sp (trans (vlax-curve-getStartPoint en) 0 1))
    (setq ep (trans (vlax-curve-getEndPoint en) 0 1))
    (cond ((not (equal sp ep 1e-8))
	   (or (notopen sp en) (setq olst (cons (list en sp) olst)))
	   (or (notopen ep en) (setq olst (cons (list en ep) olst)))
	  )
    )
  )
  (if (= 0 maxdist)
    (alert
      "\n뾡ȷһС뾶\n뾶ᵼ\nִٶȼ׼ȷ½!"
    )
  )
  (setq
    dist (getdist (strcat "\n߽뾶<" (rtos maxdist) ">:"))
  )
  (if dist
    (setq maxdist dist)
    (setq dist maxdist)
  )
  (setq i 0)
  (vla-StartUndoMark *doc*)
  (setvar "edgemode" 1)
  (setvar "cmdecho" 0)
  (setq sz (fsxm-pickboxsize))
  (setq css (ssadd))
  (foreach a olst
    (setq i (+ i (apply 'getptss (append a (list dist)))))
  )
  (vla-EndUndoMark *doc*)
  (sssetfirst nil css)
  (setq olst (itoa (length olst)))
  (princ
    (strcat "\n񱾴ι޸ڵ<" (itoa i) ">.....")
  )
  (princ)
)
(defun c:ck () (c:chkpkt))
(princ
  "\n*****ʫCAD[fsxm.mjtd.com] - ޸ :chkpkt/ck *****"
)
(setq maxdist 0)
